package com.jkcredit.asychronous.job;

import com.alibaba.fastjson.JSONArray;
import com.jkcredit.asychronous.common.ResponseEntity;
import com.jkcredit.asychronous.entity.Man;
import com.jkcredit.asychronous.service.ManService;
import com.jkcredit.asychronous.util.ExcelUtil;
import com.jkcredit.asychronous.util.FtpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Descirption
 * @Author Zhaoning Sun
 * @Date Created in 2018/6/22 下午7:34
 */
@Slf4j
@Component
public class ManJob {

    @Value("${manftp.upload.local}")
    private String localDir;
    @Value("${ftp.host}")
    private String host;
    @Value("${ftp.port}")
    private Integer port;
    @Value("${ftp.username}")
    private String userName;
    @Value("${ftp.password}")
    private String passWord;
    @Value("${ftp.dir.man}")
    private String dir;

    @Autowired
    private ManService manService;

    @Scheduled(cron = "0/10 * * * * ?")
    public void car() {
        Long beginTime= System.currentTimeMillis() - 10000;
        Long endTime = System.currentTimeMillis();
        List<Man> list = manService.selectByTime(beginTime,endTime);
//        log.info("开始 公安不良excel 导出");
        if (list.size() > 0) {
            JSONArray ja = new JSONArray();
            for(Man man : list){
                ja.add(man);
            }
            Map<String,String> headMap = new LinkedHashMap<>();
            headMap.put("name","姓名");
            headMap.put("idCard","身份证号");
            String fileName = localDir + File.separator + endTime.toString() + ".xlsx";

            try {
                OutputStream outXlsx = new FileOutputStream(fileName);
                ExcelUtil.exportExcelX(headMap,ja,null,0,outXlsx);
                outXlsx.close();
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
//            String fileName = ExcelUtil.export(list, Man.class, localDir,endTime.toString());
//            log.info("ManExcel：{}", fileName);
            FtpUtil.fileUpload(host, port, userName, passWord, dir, fileName);
        }
//        else {
//            log.error("error：{}1", new ResponseEntity(400, "公安不良信息未查到", ""));
//        }

    }

    //@Scheduled(cron = "0 0/30 * * * ?")
    public void test(){

        SimpleDateFormat df = new SimpleDateFormat("yyyyMMddHHmmss");//设置日期格式

        List<Man> list = new ArrayList<>();
        Man mantest = new Man();
        mantest.setIdCard("420581198402220816");
        mantest.setName("徐建华");
        list.add(mantest);
        JSONArray ja = new JSONArray();
        for(Man man : list){
            ja.add(man);
        }
        Map<String,String> headMap = new LinkedHashMap<>();
        headMap.put("name","姓名");
        headMap.put("idCard","身份证号");
        String fileName = localDir + File.separator + df.format(new Date()) + ".xlsx";

        try {
            OutputStream outXlsx = new FileOutputStream(fileName);
            ExcelUtil.exportExcelX(headMap,ja,null,0,outXlsx);
            outXlsx.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
//            String fileName = ExcelUtil.export(list, Man.class, localDir,endTime.toString());
//            log.info("ManExcel：{}", fileName);
        FtpUtil.fileUpload(host, port, userName, passWord, dir, fileName);
    }
}
